﻿using UnityEngine;
using UnityEditor;
using System.Collections;

public class AutoTextureImportSettings : AssetPostprocessor
{
	public void OnPreprocessTexture ()
	{
		if (assetPath.Contains("Textures/Tiles"))
		{
			var ti = assetImporter as TextureImporter;
			ti.spritePixelsPerUnit = 24f;
			ti.maxTextureSize = 32;
			SetCommonProps(ti);
		}
		if (assetPath.Contains("Textures/Characters"))
		{
			var ti = assetImporter as TextureImporter;
			ti.spritePixelsPerUnit = 32f;
			ti.maxTextureSize = 64;
			SetCommonProps(ti);
		}
		if (assetPath.Contains("Textures/Objects"))
		{
			var ti = assetImporter as TextureImporter;
			ti.spritePixelsPerUnit = 32f;
			ti.maxTextureSize = 128;
			SetCommonProps(ti);
		}
	}

	private void SetCommonProps(TextureImporter ti)
	{
		ti.mipmapEnabled = true;
		ti.textureFormat = TextureImporterFormat.AutomaticTruecolor;
		ti.filterMode = FilterMode.Point;
	}
}
