﻿using UnityEngine;
using System.Collections;

public class WeaponLaser : MonoBehaviour
{
	public float length = 5.0f;
	public float damage = 5.0f;
	public float waitMin = 2.0f;
	public float waitMax = 4.0f;
	public float fireMin = 2.0f;
	public float fireMax = 4.0f;
	public float warmup = 0.3f;
	public float rotMin = 30.0f;
	public float rotMax = 90.0f;

	LineRenderer _lr;
	Transform _tr;

	void Start ()
	{
		_tr = transform;
		_lr = GetComponent<LineRenderer>();
		_lr.sortingOrder = 10000;
		_lr.SetPosition (1, new Vector3(length,0,0));
		StartCoroutine(WeaponLogic());
	}
	
	IEnumerator WeaponLogic ()
	{
		while (true)
		{
			// wait
			_lr.enabled = false;
			yield return new WaitForSeconds(Random.Range (waitMin, waitMax));

			// fire
			var rot = Random.Range (0,360);
			var fireLeft = Random.Range (fireMin, fireMax);
			var rotSpeed = Random.Range (rotMin, rotMax) * ((Random.value >= 0.5f) ? 1.0f : -1.0f);
			_tr.rotation = Quaternion.Euler (0,0,rot);
			_lr.enabled = true;
			while (fireLeft > 0.0f)
			{
				var dt = Time.deltaTime;
				_tr.Rotate (0,0,rotSpeed * dt);
				fireLeft -= dt;

				// raycast
				var player = PlayerController.instance;
				if (player)
				{
					var hit = Physics2D.Linecast(_tr.position, _tr.TransformPoint (new Vector3(length,0,0)), LayerMask.GetMask("Player"));
					if (hit && hit.transform == player.transform)
					{
						player.DoDamage (damage);
					}
				}

				yield return 0;
			}
		}
	}
}
